/* ----------------------------------------------------------------------

	CNFTEST sample for Microsoft ActiveX Conferencing

	Unpublished work.
	Copyright (c) 1996, Microsoft Corporation
	All rights reserved.


	tbar.c

  ---------------------------------------------------------------------- */

#include "main.h"


TBBUTTON _rgtbb[] =
{
    {0,  0,                      TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0},
    {1,  IDM_CMD_CONNECT,        TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_CONNECT, 0},
    {2,  IDM_CMD_DISCONNECT,     TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_DISCONNECT, 0},
    {0,  0,                      TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0},
    {3,  IDM_CMD_GETINFO,        TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_GETINFO, 0},
    {4,  IDM_CMD_SETINFO,        TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_SETINFO, 0},
    {0,  0,                      TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0},
    {5,  IDM_CMD_SHAREWINDOW,    TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_SHAREWINDOW, 0},
    {7,  IDM_CMD_ISWINDOWSHARED, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_ISWINDOWSHARED, 0},
    {6,  IDM_CMD_UNSHAREWINDOW,  TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_UNSHAREWINDOW, 0},
    {0,  0,                      TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0},
    {8,  IDM_CMD_SENDDATA,       TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_SENDDATA, 0},
    {9,  IDM_CMD_SENDFILE,       TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_SENDFILE, 0},
    {10, IDM_CMD_LAUNCHREMOTE,   TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_CMD_LAUNCHREMOTE, 0},
    {0,  0,                      TBSTATE_ENABLED, TBSTYLE_SEP,    0, 0, 0, 0},
    {0,  IDM_ABOUT,              TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, IDT_ABOUT, 0},
};

#define cTbb sizeof(_rgtbb)/sizeof(TBBUTTON)

/* F  C R E A T E  T B A R */
/*----------------------------------------------------------------------------
	%%Function: FCreateTbar

	Create the toolbar
----------------------------------------------------------------------------*/
BOOL FCreateTbar(void)
{
	RECT rc;
	DWORD dyTbar;

	ghwndTbar = CreateToolbarEx(ghwndMain,
		WS_CHILD | WS_VISIBLE | CCS_ADJUSTABLE |
			TBSTYLE_TOOLTIPS | TBSTYLE_WRAPABLE | TBSTYLE_ALTDRAG,
		IDW_TBAR,
		NUMIMAGES,
		ghInst,
		IDB_TBAR,
		_rgtbb,
		0,
		BUTTONWIDTH,
		BUTTONHEIGHT,
		IMAGEWIDTH,
		IMAGEHEIGHT,
		sizeof(TBBUTTON));

	if (ghwndTbar == NULL)
		return fFalse;


	GetClientRect(ghwndTbar, &rc);
	dyTbar = rc.bottom;

	SendMessage(ghwndTbar, TB_ADDBUTTONS, cTbb, (LPARAM) _rgtbb);

	return fTrue;
}




/* M S G  N O T I F Y */
/*----------------------------------------------------------------------------
	%%Function: MsgNotify

----------------------------------------------------------------------------*/
LRESULT MsgNotify(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	LPTOOLTIPTEXT lpToolTipText;
	static char szBuffer[cbMaxSz];

	lpToolTipText = (LPTOOLTIPTEXT)lparam;
	switch (lpToolTipText->hdr.code)
		{
	case TTN_NEEDTEXT:
	{
		int cb;

		// Try special toolbar version first
		cb = LoadString(ghInst, lpToolTipText->hdr.idFrom - 10000,
			szBuffer, sizeof(szBuffer));
		if (cb == 0)
		{
			cb = LoadString(ghInst, lpToolTipText->hdr.idFrom,   // string ID == command ID
				szBuffer, sizeof(szBuffer));
		}
		if (cb == 0)
		{
			szBuffer[0] = '\0';
		}

		lpToolTipText->lpszText = szBuffer;
		break;
	}
	case TBN_QUERYINSERT:
	case TBN_QUERYDELETE:
		return 1;
	case PSM_SETCURSEL:
		return 1;
	default:
		break;
		}

	return 0;
}


/* F  C R E A T E  S B A R */
/*----------------------------------------------------------------------------
	%%Function: FCreateSbar

	Create the status bar.

----------------------------------------------------------------------------*/
BOOL FCreateSbar(void)
{
	ghwndSbar = CreateWindow(STATUSCLASSNAME, NULL,
		WS_CHILD | WS_VISIBLE | SBARS_SIZEGRIP,
		0, 0, 0, 0,
		ghwndMain, (HMENU) IDW_SBAR, ghInst, NULL);

	return (ghwndSbar != NULL);
}



/* U P D A T E  S T A T U S  B A R */
/*----------------------------------------------------------------------------
	%%Function: UpdateStatusBar

	Update the text for part of the status bar

----------------------------------------------------------------------------*/
void UpdateStatusBar(LPSTR lpsz, WORD wPart, WORD wFlags)
{
    SendMessage(ghwndSbar, SB_SETTEXT, wPart | wFlags, (LPARAM) lpsz);
}



/* M S G  M E N U  S E L E C T */
/*----------------------------------------------------------------------------
	%%Function: MsgMenuSelect

	Change the status bar text to display the menu help.

----------------------------------------------------------------------------*/
LRESULT MsgMenuSelect(HWND hwnd, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
	static char szBuffer[cbMaxSz];
	UINT   nStringID;
	UINT   fuFlags = GET_WM_MENUSELECT_FLAGS(wparam, lparam) & 0xffff;
	UINT   uCmd    = GET_WM_MENUSELECT_CMD(wparam, lparam);
	HMENU  hMenu   = GET_WM_MENUSELECT_HMENU(wparam, lparam);

	szBuffer[0] = 0;
	nStringID = 0;

	if (fuFlags == 0xffff && hMenu == NULL)     // Menu has been closed
	{
		return 0;
	}
	else if (fuFlags & MFT_SEPARATOR)           // Ignore separators
	{
		nStringID = 0;
	}
	else if (fuFlags & MF_POPUP)                // Popup menu
	{
		if (fuFlags & MF_SYSMENU)               // System menu
			nStringID = IDS_SYSMENU;
	}
	else                                        // Must be a command item
	{
		nStringID = uCmd;               // String ID == Command ID
	}

	// Load the string if we have an ID
	if (nStringID != 0)
		LoadString(ghInst, nStringID, szBuffer, sizeof(szBuffer));

	// Finally... send the string to the status bar
	UpdateStatusBar(szBuffer, 0, 0);

	return 0;
}
